import math
from calc_p_from_t import p_value

def sqr(x):
    return x * x

class Ccalc:
    def __init__(self, pairs):
        self.pairs = pairs

    def calc(self):

        n = len(self.pairs)
        print("n = %d"%n)

        sum_x = 0.0
        sum_y = 0.0
        for i in range(0, n):
            sum_x += self.pairs[i][0]
            sum_y += self.pairs[i][1]
        mean_x = sum_x / n
        mean_y = sum_y / n
        print("Mean_x = %f"%mean_x)
        print("Mean_y = %f"%mean_y)
        ssum_x = 0.0
        ssum_y = 0.0
        sum_xy = 0.0
        for i in range(0, n):
            ssum_x += sqr(self.pairs[i][0] - mean_x)
            ssum_y += sqr(self.pairs[i][1] - mean_y)
            sum_xy += (self.pairs[i][0] - mean_x) * (self.pairs[i][1] - mean_y)

        var_x = ssum_x / n
        var_y = ssum_y / n
        print("Var_x = %f"%var_x)
        print("Var_y = %f"%var_y)
        sd_x = math.sqrt(var_x)
        sd_y = math.sqrt(var_y)
        print("sd_x = %f"%sd_x)
        print("sd_y = %f"%sd_y)
        cor = sum_xy / math.sqrt(ssum_x * ssum_y)
        print("r = %f"%cor)

        t = cor * math.sqrt(n - 2.0) / math.sqrt(1.0 - (cor ** 2.0))
        df = n - 2
        p = p_value(t, df)
       
        return t, df, p
